<template>
  <div>
    <div v-for="(colorGroup, index) in colorGroups" :key="index" class="group">
      <h3>{{ colorGroup.title }}</h3>
      <p>{{ colorGroup.description }}</p>
      <ul>
        <li v-for="color in colorGroup.colors" :key="color" :class="color">
          {{ color[0] }}
        </li>
      </ul>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      colorGroups: [
        {
          title: 'Primary',
          description:
            'This should be the main color throughout the app – use for text, links, backgrounds and highlights.',
          colors: [
            ['primary-dark', 'dark'],
            ['primary', 'dark'],
            ['primary-light', 'light'],
            ['primary-tint', 'light']
          ]
        },
        {
          title: 'Grey',
          description:
            'Use grey shades for borders, backgrounds and subtle text.',
          colors: [
            ['grey-dark', 'dark'],
            ['grey', 'dark'],
            ['grey-light', 'light'],
            ['grey-tint', 'light']
          ]
        },
        {
          title: 'Mono',
          description:
            'Pure black and white for backgrounds and text. Use primary dark before black where possible.',
          colors: [
            ['black', 'dark'],
            ['white', 'light']
          ]
        },
        {
          title: 'Danger',
          description: 'Use danger colors for errors and destructive actions.',
          colors: [
            ['danger-dark', 'dark'],
            ['danger-light', 'light'],
            ['danger-tint', 'light']
          ]
        },
        {
          title: 'Warning',
          description: 'Use warning colors for important information.',
          colors: [
            ['warning-dark', 'dark'],
            ['warning-light', 'light'],
            ['warning-tint', 'light']
          ]
        },
        {
          title: 'Success',
          description: 'Use success colors for successful actions and notices.',
          colors: [
            ['success-dark', 'dark'],
            ['success-light', 'light'],
            ['success-tint', 'light']
          ]
        },
        {
          title: 'Secondary',
          description:
            'Use sparingly to add color to designs. Check contrast for accessibility/legibility when using with text.',
          colors: [
            ['yellow', 'light'],
            ['orange', 'light'],
            ['magenta', 'dark'],
            ['red', 'dark'],
            ['blue-light', 'light'],
            ['cerulean', 'light'],
            ['blue', 'light'],
            ['blue-dark', 'dark'],
            ['pink', 'light'],
            ['purple-light', 'light'],
            ['purple', 'dark'],
            ['purple-dark', 'dark'],
            ['green-light', 'light'],
            ['green', 'light'],
            ['turquoise', 'light'],
            ['green-dark', 'dark']
          ]
        }
      ]
    }
  }
}
</script>

<style lang="scss" scoped>
.group {
  margin: spacing(3) 0;
}
h3 {
  font-size: font-size(2);
}
p {
  color: color(grey);
}
ul {
  margin-top: spacing(1);
  list-style: none;
}
li {
  display: inline-block;
  width: 10rem;
  height: 10rem;
  margin: spacing(0);
  padding: spacing(1);
  border-radius: $border-radius;
  &.dark {
    color: color(white);
  }
}
@each $name, $value in $color {
  li.#{'' + $name} {
    background: $value;
    &::after {
      display: block;
      content: '#{$value}';
      font-size: font-size(0);
    }
  }
}
</style>
